;=======================================================
; Cheep Cheep Dolphin Thing
; By Erik557
;=======================================================
; Description: A cheep-cheep that follows a pattern
; similar to an original game dolphin.
; Uses first extra bit: YES
; When clear, the fish will act like a vertical dolphin.
; Else, it will act like an horizontal one.
;=======================================================

Tilemap:
       db $67,$69
XSpeeds:
       db $E8,$18

;=================================
; INIT and MAIN Wrappers
;=================================

print "MAIN ",pc
       PHB
       PHK
       PLB
       JSR CheepCheep
       PLB
print "INIT ",pc
       RTL

;========================
; Main routine
;========================

CheepCheep:
       JSR Graphics
       LDA $14C8,x
       CMP #$08
       BNE .return
       LDA $9D
       BNE .return
       LDY #$02
       JSR SubOffScreen
       JSL $01801A
       JSL $018022
       LDA $AA,x
       BMI +
       CMP #$3F
       BCS .dontIncSpeed
+      INC $AA,x
.dontIncSpeed
       TXA
       EOR $13
       LSR
       BCC +
       JSL $019138
+      LDA $AA,x
       BMI .dontSetSpeed
       LDA $164A,x
       BEQ .dontSetSpeed
       LDA $AA,x
       BEQ .dontZeroSpeed
       SEC
       SBC #$08
       STA $AA,x
       BPL .dontZeroSpeed
       STZ $AA,x
.dontZeroSpeed
       LDA $7FAB10,x
       AND #$04
       BEQ .dontSetX
       LDA $AA,x
       BNE .dontSetSpeed
       LDA $C2,x
       AND #$01
       TAY
       LDA XSpeeds,y
       STA $B6,x
.dontSetX
       INC $C2,x
       LDA #$C0
       STA $AA,x
.dontSetSpeed
       LDA $C2,x
       AND #$01
       STA $157C,x
.interRet
       JSL $01A7DC
.return
       RTS

;========================
; Graphics routine
;========================

Graphics:
       JSR GetDrawInfo
       LDA $157C,x
       STA $02
       REP #$20
       LDA $00
       STA $0300,y
       SEP #$20
       LDA $14
       LSR #3
       AND #$01
       TAX
       LDA Tilemap,x
       STA $0302,y
       LDX $02
       LDA Props,x
       LDX $15E9
       ORA $15F6,x
       ORA $64
       STA $0303,y
       LDY #$02
       TDC
       JSL $01B7B3
       RTS

Props:
       db $40,$00

;========================
; Misc. subroutines
;========================

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  GetDrawInfo:            ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$20
       SEC
       SBC $1A
       STA $00
       CLC
       ADC #$0040
       CMP #$0180
       SEP #$20
       LDA $01
       BEQ +
       LDA #$01
+      STA $15A0,x
       TDC
       ROL A
       STA $15C4,x
       BNE .Invalid
       LDA $14D4,x
       XBA
       LDA $1662,x
       AND #$20
       BEQ .CheckOnce
.CheckTwice
       LDA $D8,x
       REP #$21
       ADC #$001C
       SEC
       SBC $1C
       SEP #$20
       LDA $14D4,x
       XBA
       BEQ .CheckOnce
       LDA #$02
.CheckOnce
       STA $186C,x
       LDA $D8,x
       REP #$21
       ADC #$000C
       SEC
       SBC $1C
       SEP #$21
       SBC #$0C
       STA $01
       XBA
       BEQ .OnScreenY
       INC $186C,x
.OnScreenY
       LDY $15EA,x
       RTS

.Invalid
       PLA
       PLA
       RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  SubOffScreen:           ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       LDA $15A0,x
       ORA $186C,x
       BEQ .Return2
       LDA $167A,x
       AND #$04
       BNE .Return2
       LDA $5B
       LSR A
       BCS .VerticalLevel
       LDA $D8,x
       ADC #$50
       LDA $14D4,x
       ADC #$00
       CMP #$02
       BCS .EraseSprite
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC .AddTable,y
       SEC
       SBC $1A
       CMP .CmpTable,y
.Common
       SEP #$20
       BCC .Return2
.EraseSprite
       LDA $14C8,x
       CMP #$08
       BCC .KillSprite
       LDY $161A,x
       CPY #$FF
       BEQ .KillSprite
       LDA $1938,y
       AND #$FE
       STA $1938,y
.KillSprite
       STZ $14C8,x
.Return2
       RTS

.VerticalLevel
       LDA $13
       LSR A
       BCS .CheckY
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC.w #$0040
       CMP.w #$0280
       BRA .Common
.CheckY
       LDA $14D4,x
       XBA
       LDA $D8,x
       REP #$20
       SBC $1C
       CLC
       ADC.w #$0070
       CMP.w #$01D0
       BRA .Common

.AddTable
       dw $0040,$0040,$0010,$0070
       dw $0090,$0050,$0080,$FFC0
.CmpTable
       dw $0170,$01E0,$01B0,$01D0
       dw $0230,$01B0,$0220,$0160

